/**
 * apeman template of dot files.
 * @memberof module:apeman-tmpl-dot/lib
 * @function load
 * @param {object} params - Template params.
 * @param {string} [mode='644'] - File permission.
 * @param {boolean} [force=false] - Override or not.
 * @returns {object} - Coz bud configuration.
 */

"use strict";

var argx = require('argx'),
    assert = require('assert'),
    fs = require('fs');

var _types = require('./_types');

/** @lends load */
function load(params, mode, force) {
    var args = argx(arguments);
    params = args.shift('object');

    assert(params.type, "params.type is required.");
    return {
        force: !!force,
        mode: mode || '644',
        get tmpl() {
            var filename = _types[params.type];
            assert.ok(filename, "Type not found: " + params.type);
            return fs.readFileSync(__dirname + '/../' + filename).toString();
        },
        data: {}
    }
}

module.exports = load;
